
/*** INTERS1.C ***/

float Const; /* Constante usada na construcao da intersecao */

float F1(float x, float y, float z) { return f1(x, y) - g1(Const, z); }
float F2(float x, float y, float z) { return f2(x, y) - g2(Const, z); }
float F3(float x, float y, float z) { return f3(x, y) - g3(Const, z); }

/* ------------------------------------------------------------------------ */

float G1(float x, float y, float z) { return f1(x, y) - g1(z, Const); }
float G2(float x, float y, float z) { return f2(x, y) - g2(z, Const); }
float G3(float x, float y, float z) { return f3(x, y) - g3(z, Const); }

/* ------------------------------------------------------------------------ */

float H1(float x, float y, float z) { return g1(x, y) - f1(Const, z); }
float H2(float x, float y, float z) { return g2(x, y) - f2(Const, z); }
float H3(float x, float y, float z) { return g3(x, y) - f3(Const, z); }

/* ------------------------------------------------------------------------ */

float I1(float x, float y, float z) { return g1(x, y) - f1(z, Const); }
float I2(float x, float y, float z) { return g2(x, y) - f2(z, Const); }
float I3(float x, float y, float z) { return g3(x, y) - f3(z, Const); }

/* ------------------------------------------------------------------------ */

#ifdef VERIFICA_LIMITES_DOMINIO

void InterceptaSup(float (*f1) (float, float), float (*f2) (float, float),
		   float (*f3) (float, float), float (*g1) (float, float),
       float (*g2) (float, float), float (*g3) (float, float), float umin,
		float umax, float vmin, float vmax,
		float x0_aprox, float y0_aprox, float z0_aprox) {

  float u, v, x, y, z, x2, y2, z2;
  float x_0[3], sol[3], Erro = 1E-5;
  int n;

  for (u = umin; u <= umax; u += 2*inc) {
    Const = u;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(F1, F2, F3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT && sol[0] >= umin && sol[0] <= umax &&
      sol[1] <= vmax && sol[1] >= vmin && sol[2] <= vmax && sol[2] >= vmin
    ) {
      x = f1(sol[0], sol[1]);
      y = f2(sol[0], sol[1]);
      z = f3(sol[0], sol[1]);
      x2 = g1(Const, sol[2]);
      y2 = g2(Const, sol[2]);
      z2 = g3(Const, sol[2]);
      if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

  for (u = umin; u <= umax; u += 2*inc) {
    Const = u;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(H1, H2, H3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT && sol[0] >= umin && sol[0] <= umax &&
      sol[1] <= vmax && sol[1] >= vmin && sol[2] <= vmax && sol[2] >= vmin
    ) {
      x = g1(sol[0], sol[1]);
      y = g2(sol[0], sol[1]);
      z = g3(sol[0], sol[1]);
      x2 = f1(Const, sol[2]);
      y2 = f2(Const, sol[2]);
      z2 = f3(Const, sol[2]);
      if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

  /* ---------------- */

  for (v = vmin; v <= vmax; v += 2*inc) {
    Const = v;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(G1, G2, G3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT && sol[0] >= umin && sol[0] <= umax &&
      sol[1] <= vmax && sol[1] >= vmin && sol[2] <= umax && sol[2] >= umin
    ) {
      x = f1(sol[0], sol[1]);
      y = f2(sol[0], sol[1]);
      z = f3(sol[0], sol[1]);
      x2 = g1(sol[2], Const);
      y2 = g2(sol[2], Const);
      z2 = g3(sol[2], Const);
      if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

  for (v = vmin; v <= vmax; v += 2*inc) {
    Const = v;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(I1, I2, I3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT  && sol[0] >= umin && sol[0] <= umax &&
      sol[1] <= vmax && sol[1] >= vmin && sol[2] <= umax && sol[2] >= umin
    ) {
      x = g1(sol[0], sol[1]);
      y = g2(sol[0], sol[1]);
      z = g3(sol[0], sol[1]);
      x2 = f1(sol[2], Const);
      y2 = f2(sol[2], Const);
      z2 = f3(sol[2], Const);
      if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

}

#else

/* ------------------------------------------------------------------------ */

void CalculaMaxMin(float (*f1) (float, float), float (*f2) (float, float),
     float (*f3) (float, float), float umin, float umax, float vmin,
     float vmax, float *xmin, float *xmax, float *ymin, float *ymax,
     float *zmin, float *zmax) {

  float u, v, xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, xp4, yp4, zp4;

  *xmax = *xmin = f1(umin, vmin);
  *ymax = *ymin = f2(umin, vmin);
  *zmax = *zmin = f3(umin, vmin);

  for (u = umin + (umax - umin)/nu; u <= umax + (umax - umin)/(2*nu);
						       u += (umax - umin)/nu)
    for (v = vmin + (vmax - vmin)/nv; v <= vmax + (vmax - vmin)/(2*nv);
						       v += (vmax - vmin)/nv) {
      xp1 = f1(u, v);
      yp1 = f2(u, v);
      zp1 = f3(u, v);
      if (*xmax < xp1) *xmax = xp1;
      if (*xmin > xp1) *xmin = xp1;
      if (*ymax < yp1) *ymax = yp1;
      if (*ymin > yp1) *ymin = yp1;
      if (*zmax < zp1) *zmax = zp1;
      if (*zmin > zp1) *zmin = zp1;

      xp2 = f1(u - (umax - umin)/nu, v);
      yp2 = f2(u - (umax - umin)/nu, v);
      zp2 = f3(u - (umax - umin)/nu, v);
      if (*xmax < xp2) *xmax = xp2;
      if (*xmin > xp2) *xmin = xp2;
      if (*ymax < yp2) *ymax = yp2;
      if (*ymin > yp2) *ymin = yp2;
      if (*zmax < zp2) *zmax = zp2;
      if (*zmin > zp2) *zmin = zp2;

      xp3 = f1(u, v - (vmax - vmin)/nv);
      yp3 = f2(u, v - (vmax - vmin)/nv);
      zp3 = f3(u, v - (vmax - vmin)/nv);
      if (*xmax < xp3) *xmax = xp3;
      if (*xmin > xp3) *xmin = xp3;
      if (*ymax < yp3) *ymax = yp3;
      if (*ymin > yp3) *ymin = yp3;
      if (*zmax < zp3) *zmax = zp3;
      if (*zmin > zp3) *zmin = zp3;

      xp4 = f1(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      yp4 = f2(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      zp4 = f3(u - (umax - umin)/nu, v - (vmax - vmin)/nv);
      if (*xmax < xp4) *xmax = xp4;
      if (*xmin > xp4) *xmin = xp4;
      if (*ymax < yp4) *ymax = yp4;
      if (*ymin > yp4) *ymin = yp4;
      if (*zmax < zp4) *zmax = zp4;
      if (*zmin > zp4) *zmin = zp4;

    }
}

/* ------------------------------------------------------------------------ */

void InterceptaSup2(float (*f1) (float, float), float (*f2) (float, float),
		   float (*f3) (float, float), float (*g1) (float, float),
       float (*g2) (float, float), float (*g3) (float, float), float umin,
		float umax, float vmin, float vmax,
		float x0_aprox, float y0_aprox, float z0_aprox) {

  float u, v, x, y, z, x2, y2, z2, xmin, xmax, ymin, ymax, zmin, zmax,
	xmin2, xmax2, ymin2, ymax2, zmin2, zmax2;
  float x_0[3], sol[3], Erro = 1E-5;
  int n;

  CalculaMaxMin(f1, f2, f3, umin, umax, vmin, vmax, &xmin, &xmax,
		&ymin, &ymax, &zmin, &zmax);
  CalculaMaxMin(g1, g2, g3, umin, umax, vmin, vmax, &xmin2, &xmax2,
		&ymin2, &ymax2, &zmin2, &zmax2);
  if (xmin > xmin2) xmin = xmin2;
  if (xmax < xmax2) xmax = xmax2;
  if (ymin > ymin2) ymin = ymin2;
  if (ymax < ymax2) ymax = ymax2;
  if (zmin > zmin2) zmin = zmin2;
  if (zmax < zmax2) zmax = zmax2;

  for (u = umin; u <= umax; u += 2*inc) {
    Const = u;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(F1, F2, F3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT) {
      x = f1(sol[0], sol[1]);
      y = f2(sol[0], sol[1]);
      z = f3(sol[0], sol[1]);
      x2 = g1(Const, sol[2]);
      y2 = g2(Const, sol[2]);
      z2 = g3(Const, sol[2]);
      if (x >= xmin && x <= xmax && y >= ymin && y <= ymax &&
						    z >= zmin && z <= zmax)
	if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	  DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

  for (u = umin; u <= umax; u += 2*inc) {
    Const = u;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(H1, H2, H3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT) {
      x = g1(sol[0], sol[1]);
      y = g2(sol[0], sol[1]);
      z = g3(sol[0], sol[1]);
      x2 = f1(Const, sol[2]);
      y2 = f2(Const, sol[2]);
      z2 = f3(Const, sol[2]);
      if (x >= xmin && x <= xmax && y >= ymin && y <= ymax &&
						    z >= zmin && z <= zmax)
	if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	  DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

  /* ---------------- */

  for (v = vmin; v <= vmax; v += 2*inc) {
    Const = v;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(G1, G2, G3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT && sol[0] >= umin && sol[0] <= umax &&
      sol[1] <= vmax && sol[1] >= vmin && sol[2] <= umax && sol[2] >= umin
    ) {
      x = f1(sol[0], sol[1]);
      y = f2(sol[0], sol[1]);
      z = f3(sol[0], sol[1]);
      x2 = g1(sol[2], Const);
      y2 = g2(sol[2], Const);
      z2 = g3(sol[2], Const);
      if (x >= xmin && x <= xmax && y >= ymin && y <= ymax &&
						      z >= zmin && z <= zmax)
	if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	  DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

  for (v = vmin; v <= vmax; v += 2*inc) {
    Const = v;
    x_0[0] = x0_aprox; x_0[1] = y0_aprox; x_0[2] = z0_aprox;
    n = ResolveSistema(I1, I2, I3, x_0, 1E-8, MAX_IT, sol);
    if (n > 0 && n < MAX_IT) {
      x = g1(sol[0], sol[1]);
      y = g2(sol[0], sol[1]);
      z = g3(sol[0], sol[1]);
      x2 = f1(sol[2], Const);
      y2 = f2(sol[2], Const);
      z2 = f3(sol[2], Const);
      if (x >= xmin && x <= xmax && y >= ymin && y <= ymax &&
						       z >= zmin && z <= zmax)
	if (DISTANCIA(x, y, z, x2, y2, z2) <= Erro)
	  DesenhaPonto(x, y, z);
      else pontos_descartados++;
    }
  }

}

#endif

/* ------------------------------------------------------------------------ */

/*** FIM DE INTERS1.C ***/

